ins = zeros(100, 1);
cam = zeros(100, 1);

for i=1:100
    ins(i) = rand()-0.5;
end
ins = filter([1/4 1/4 1/4 1/4], 1, ins);

for i=1:80
    cam(i+20) = ins(i)*0.8;
end

camdiff = filter([-1 0 1],1,cam);
insdiff = filter([-1 0 1],1,ins);

%cam = circshift(cam,50);

q = zeros(50,1);
for dt=1:50
    for t=2:100
       if (t+dt) < 100
           q(dt) = q(dt) + (insdiff(t) - camdiff(t + dt))^2;
       end
    end
end
figure(1);
clf;
hold on;
plot(ins,'r');
plot(cam,'b');
xlabel('Time [ms]');
ylabel('Measurement (rad)');
legend('Signal 1', 'Signal 2');
hold off
figure(2);
clf
plot(q,'k');
xlabel('Delta t');
ylabel('Error');
legend('Error (q)');
figure(3);
clf
plot(insdiff,'r');
hold on
plot(camdiff,'b');
xlabel('Time [ms]');
ylabel('Measurement first derivative')
legend('Signal 1 derivative', 'Signal 2 derivative');
figure(4)
clf
plot(ins(1:80),'r');
hold on
plot(cam(21:100),'b');
xlabel('Time [ms]');
ylabel('Measurement (rad)');
legend('Signal 1', 'Signal 2, synchronized');